<?
header("Content-Type: text/plain");
ob_start();
ob_implicit_flush(0);

require("../conf/mysql_conf.php");
require("../inc/MySQLSession.class.php");

$sess= new MySQLSession($mysql_conf, true);

$query_string = "	SELECT 
				year,
				region, 
				sum(util_aid) as util_aid,
				sum(food_aid) as food_aid, 
				sum(util_aid/util_aid) as util_count,
				
				sum(food_aid/food_aid) as food_count,
				sum(dist_indust) as dist_indust, 
				sum(dist_agri) as dist_agri, 
				sum(dist_tech) as dist_tech, 
				sum(dist_other) as dist_other, 
				sum(dist_indust/dist_indust) as dist_count
			FROM ui_data
			GROUP BY year, region";

$result = $sess->query($query_string);

$data = "";

while ($row = @mysql_fetch_array($result))
{
	if ($row["dist_count"]==0) $row["dist_count"] = 1;
	if ($row["food_count"]==0) $row["food_count"] = 1;
	if ($row["util_count"]==0) $row["util_count"] = 1;
	
	$data .= $row["year"] . ";";
	$data .= $row["region"] .";";

	$data .= number_format($row["util_aid"]/$row["util_count"] , 2) . ";";
	$data .= number_format($row["food_aid"]/$row["food_count"] , 2) . ";";
	
	$data .= number_format($row["dist_indust"]/$row["dist_count"] , 2) . ";";
	$data .= number_format($row["dist_agri"]/$row["dist_count"] , 2) . ";";
	$data .= number_format($row["dist_tech"]/$row["dist_count"] , 2) . ";";
	$data .= number_format($row["dist_other"]/$row["dist_count"] , 2) . ";";
	$data .= "\n";
}
echo $data;

$contents = ob_get_contents();
ob_end_clean();


header("Content-Encoding: gzip");

echo "\x1f\x8b\x08\x00\x00\x00\x00\x00";

// Figure out the size and CRC of the original for later
$Size = strlen($contents);
$Crc = crc32($contents);

// Compress the data
$contents = gzcompress($contents, 9);

// We can't just output it here, since the CRC is messed up.
// If I try to "echo $contents" at this point, the compressed
// data is sent, but not completely.  There are four bytes at
// the end that are a CRC.  Three are sent.  The last one is
// left in limbo.  Also, if we "echo $contents", then the next
// byte we echo will not be sent to the client.  I am not sure
// if this is a bug in 4.0.2 or not, but the best way to avoid
// this is to put the correct CRC at the end of the compressed
// data.  (The one generated by gzcompress looks WAY wrong.)
// This will stop Opera from crashing, gunzip will work, and
// other browsers won't keep loading indefinately.
//
// Strip off the old CRC (it's there, but it won't be displayed
// all the way -- very odd)
$contents = substr($contents, 0, strlen($contents) - 4);

// Show only the compressed data
echo $contents;

// Output the CRC, then the size of the original
gzip_PrintFourChars($Crc);
gzip_PrintFourChars($Size);


// Done.  You can append further data by gzcompressing
// another string and reworking the CRC and Size stuff for
// it too.  Repeat until done.


function gzip_PrintFourChars($Val)
{
    for ($i = 0; $i < 4; $i ++)
    {
        echo chr($Val % 256);
        $Val = floor($Val / 256);
    }
}
?>
