/* 
-------------------------------------------------------------------------
./logicaland 0.1 - a participative global simulation
-------------------------------------------------------------------------
Copyright (c) 2002 ./logicaland (http://www.logicaland.net)
Michael Aschauer, Josef Deinhofer (io@logicland.net)
-------------------------------------------------------------------------
For information on usage and redistribution, and for a DISCLAIMER OF ALL
WARRANTIES, see the file, "LICENSE.txt," in this distribution.  
-------------------------------------------------------------------------
*/

package logica.sim;

import logica.sim.data.*;


public class Year {
	public Vars v;
	public SimData s;
	public WorldData w;
	public RegionData r[];


	public Year (Vars vArg) {
		v = vArg;
		s = new SimData();
		w = new WorldData();

		r = new RegionData[v.numRegs];
		for (int i = 0; i < v.numRegs; i++) r[i] = new RegionData();
	}


	public void isCopyOf (Year yr) {
		v = yr.v;
		s = yr.s;

		w.isCopyOf(yr.w);
		for (int i = 0; i < v.numRegs; i++) r[i].isCopyOf(yr.r[i]);
	}
}